; ----------------------------------------------------------------------------------------------------------------------- 
Float2Asc	PROTO: DWORD, :DWORD

f2sPrec =	7	; ->f2sDigits; max 16-18 digits (7 is default for FloatToStr); see also f2sSeed
SwScNot =	-3	; if exponent < n, switch to scientific notation
ExRange equ	150	; range ca. e-150...e+150
signed	equ sdword ptr 
; --------------------------------------------------------------
; yields info how to push arg on FPU, and the argument to pass
; 4	Int32, reg32, reg16, reg8, immediate32
; 5	Real4	(called as @MyReal4)
; 8	Real 8	(also immediate real number)
; 10	Real10

ChkNum MACRO argX:REQ
LOCAL ArgType, tmp$, arg, nu8, dot, deco
  aPass$ equ <0>					;; several times redefined, no problem...!
  arg equ <argX>					;; sizes: 0=fild, 1=R4, 2=R8, 3=R10
  NumSize = -1					;; global return value, -1=error
  ifb <argX>
	crash
	EXITM <0>					;; no argument passed
  endif
  dot INSTR arg, < >				;; leading space?
  if dot eq 1
	arg SUBSTR arg, 2			;; strip one leading space
  endif
  dot INSTR arg, < >				;; leading space?
  if dot
	arg SUBSTR arg, 1, dot-1		;; strip trailing spaces
  endif
  dot INSTR arg, <.>				;; immediate real?
  deco INSTR arg, <@>			;; REAL4, size 4 but decorated?
  if deco eq 0
	deco INSTR arg, <eal4>		;; dirty hack for TestNum
  endif
  tmp$ CATSTR <t=>,<arg>, <, hasdot=>, %dot, <, hasdeco=>, %deco
  % echo tmp$
  if deco
  	if deco eq 1						;; to distinguish Real4 from Int32,
		arg SUBSTR arg, 2			;; we decorate with a @
		% echo <arg> was decorated
	endif
	NumSize = 1				;; REAL4
	ArgType = (opattr(arg)) AND 127
	if ArgType eq atLocal
		t$ CATSTR <lea eax, >, <arg>
		t$
		aPass$ equ eax			;; eax will be trashed when using a LOCAL
		t$ equ <Local REAL4>
	else
		aPass$ CATSTR <offset >, <arg>
		t$ equ <REAL4>
	endif
  elseif dot
	.data
		nu8 REAL8 arg			;; write arg to .DATA section
	.code
	NumSize = 2				;; Real8
	aPass$ equ <offset nu8>	;; we pass it as a pointer to the new Real8
	t$ equ <immediate Real8>
  else								;; none of the above
	ArgType = (opattr(arg)) AND 127			;; 0 no vn$, 36 immediate, 42 global, 48 CPU register, 98 local
	if ArgType eq atLocal or ArgType eq atGlobal
		RealSize = SIZEOF arg	;; 4 for DWORD, 10 for REAL10
		if RealSize eq 4
			NumSize = 0	;; Integer
			tmp$ CATSTR <mov eax, >, <arg>
			% echo tmp$
			tmp$				;; insert code
			aPass$ equ eax		;; eax will be trashed
			t$ equ <Int32>
			% echo t$
			% echo aPass$
			echo
		else
			if ArgType eq atLocal
				tmp$ CATSTR <lea eax, >, <arg>
				tmp$				;; insert lea code (instead of addr)
				aPass$ equ eax		;; eax will be trashed when using a LOCAL
			else
				aPass$ CATSTR <offset >, <arg>
			endif
			if RealSize eq 8
				NumSize = 2	;; Real8
				t$ equ <REAL8>
			elseif RealSize eq 10
				NumSize = 3	;; Real10
				t$ equ <REAL10>
			else
				echo Size %RealSize no good, sorry
				.err
			endif
		endif
	elseif ArgType eq atImmediate
;		tmp$ CATSTR <Immediate passed: >, arg
;		% echo tmp$
		NumSize = 0			;; immediate integer
		tmp$ CATSTR <mov eax, >, <arg>
		tmp$
		aPass$ equ eax			;; push it using eax
		t$ equ <immediate DWORD>
	elseif ArgType eq atRegister
		RealSize SIZESTR arg
		NumSize = 0			;; register as int32
		if RealSize eq 3			;; full size register
			aPass$ equ arg		;; push it "as is"
			t$ equ <DWORD reg>
		else
;			% echo checking register for <arg>
			t$ SUBSTR arg, 1, 1		;; e.g. ax, ah, el, cx
;			% echo t$
			tmp$ CATSTR <movzx e>,t$, <x, >, <arg>
;			% echo tmp$
			tmp$	; insert code, e.g. movzx ecx, cl
			aPass$ CATSTR <e>, t$, <x>	; ecx etc
;			% echo aPass$
			dot INSTR arg, <x>
			tmp$ CATSTR <dooot >,%dot, < for >, arg
			% echo tmp$
			if dot eq 0
				t$ equ <BYTE reg>
			else
				t$ equ <WORD reg>
			endif
;			% echo t$

		endif
	endif
  endif
  if NumSize lt 0
	 tmp$ catstr arg, < is >, %ArgType, <, with size >, %NumSize
	% echo tmp$
	.err
  endif
  EXITM <NumSize>
ENDM

;        OPATTR guide
;     Bit	Set If...
;     0	References a code label
;     1	Is a memory expression or has a relocatable data label
;     2	Is an immediate expression
;     3	Uses direct memory addressing, i.e. is an absolute memory reference
;     4	Is a register expression
;     5	References no undefined symbols and is without error
;     6	References a stack location (usually a LOCAL variable or parameter)
;     7	References an external label
;     8-10	Language type (0=no type)
		; 76543210
atImmediate	equ 36	; 00100100
atGlobal	equ 42	; 00101010
atRegister	equ 48	; 00110000
atLocal	equ 98	; 01100010

float$ MACRO strformat, num	;; example: print float$("\nMy number is %f", MyReal8)
LOCAL P$, PP, PP_o, parseLen, c$, co$, AriMode, AriMult, CurAri, LastAri, NegFlag, CurNum$, argct, slot$, aSize1, HasDot
LOCAL f2sMS, ArgType, atyB, asiB, tmp$, quotes, arg1a, arg2a, arg3a, arg4a, mode$, FF$, nustr
LOCAL aPass1, aPass2, aPass3, aPass4	; ArgSize global for TestNum
  mov edx, offset f2sSlots
  HasDot	= 0	;; immediate reals, 1.234e44
  NegFlag	= 0	;; if a para starts with -
  f2sMS	= 0	;; combined mode and size parameter
  argct	= 0	;; argument counter (4 num args max)
  PP	= 0	;; startpos in parse$
  PP_o	= 1	;; ParsePos old
  ; ArgSize =	0	;; for TestNum
  ; AriMode =	0	;; arithmetic mode
  LastAri =	0	;; prev mode, e.g. 123+MyInt* when * is found
  AriMult =	1	;; ari multiplier
  FF$ equ	<0>	;; FloatFormat$: if 0, just print the number
  quotes	INSTR <strformat>, <">
  if quotes eq 0
	quotes	INSTR <strformat>, <'>
  endif
  if quotes eq 1
	P$ CATSTR <num>, <>		;; first arg is a format string
	FF$ equ <offset nustr>		;; we pass it as FF$
	.data
		nustr db strformat, 0		;; write arg to .DATA section
	.code
  else
	P$	CATSTR <strformat>, <>	;; first arg is not format but the number itself
  endif
 
  parseLen SIZESTR P$

; tmp$ CATSTR <We scan >, P$, <, >, %parseLen, < bytes>
; % echo tmp$

  WHILE PP lt parseLen	; Repeat until Parse Position >= LEN(P$)
	PP=PP+1	; Position in Parse$
	c$ SUBSTR P$,PP,1
	CurAri INSTR <+-*/.eE>, c$	; 1234; and 8: neg before continuing
	if CurAri eq 2
		if PP eq PP_o
			NegFlag=32
			CurAri=0
			PP_o=PP+1
			tmp$ CATSTR <MINUS: pp=>, %PP, <, ppo=>, %PP_o
			% echo tmp$
		endif
	endif
	if CurAri eq 6
		HasDot = 1
		% echo ThisStringHasDot: <P$>
		CurAri = 0
	endif
	if CurAri gt 6
		CurAri = 0
		tmp$ SUBSTR P$, 1, PP
		if HasDot
			PP = PP + 1	;; skip 123e+1
			tmp$ CATSTR <We skipped >, tmp$
		else
			tmp$ CATSTR <NO DOT in >, tmp$
		endif
		% echo tmp$
	endif
	if CurAri
		CurNum$ SUBSTR P$,PP_o,PP-PP_o
;		tmp$ CATSTR <t=x>,CurNum$, <x, P1=>, %PP, <, P2=>, %PP_o
;		% echo tmp$
		CurMS = LastAri + 8 * ChkNum(CurNum$)+NegFlag
;		tmp$ CATSTR <CurMSize=>, %CurMS, <, of which ari=>, %LastAri
;		% echo tmp$
		f2sMS = f2sMS + AriMult * CurMS	;; mode (bits 0-2, 0-7) and NumSize (bits 3-5, 8*(0-3), bit 6 reserved for NegFlag)
		LastAri = CurAri
		NegFlag = 0		;; clear the flag
;		tmp$ CATSTR <We pass >, aPass$
;		% echo tmp$

		mov [edx], aPass$
		add edx, 4
		; echo done

		tmp$ CATSTR <ModeSize=>, %f2sMS
		% echo tmp$
		AriMult = AriMult * 64		;; 5*6=30: 0...7 sizes: 0=fild, 1=R4, 2=R8, 3=R10, 0...7 ari, 8=neg 000 001 010 011 100 101 110 111
		; % aPass1 equ aPass$
		if argct
			slot$ CATSTR <mov [edx+>, %argct*4, <], >, aPass$
		else
			slot$ CATSTR <mov [edx], >, aPass$
			ArgSize = NumSize		;; for TestNum
		endif
		argct = argct + 1
		if argct eq 6
			echo too many arguments
			.err
		endif
		PP_o = PP+1
		HasDot = 0
		% echo slot$
		echo
	endif
  ENDM
  % invoke Float2Asc, FF$, f2sMS

; slot 0 taken: it's float$; FF$ or 0, f2sMS, slot 0: arg0, slot 1: arg1 etc
; slots not taken: FF$ or 0, Real8
 ;  invoke FloatStr: 0 or 100, addr x = Real10, 40, addr x = Real4, 80, addr x = Real8, addr FF$, addr x = Real8
 ;  invoke FloatStr: n, FF$ for macro invokes with n=1-4
  EXITM <eax>
ENDM

.data?
f2sTmpBuf	dd 10 dup(?)	; internal buffer for f2sForm$
f2sSlots	dd 6 dup(?)	; 5+1 for flagging last slot
f2sP10	REAL8 ExRange+5 dup(?)
f2sP10Mid	REAL8 ?
	REAL8 ExRange-1-5 dup(?)
f2sDummy	dw ?
f2sBuffer	dd 80 dup(?)	; returned by float$

.data
sprintFormat	db "%.7g", 0
align 4
f2sSeed	REAL10 1.000000000000000004e+156
;f2sSeed	@CatStr(<REAL10 1.00000000000000001e+>,%ExRange+6)
f2s0dot1	REAL10	0.1
f2sRnd05	REAL8	0.5		; a for dwtoa

.code
Float2Asc proc	f2sForm$:DWORD,		; pointer to e.g. "The relation A:B is %f"
	f2sMS:DWORD		; pointer to ModeSize or to first number
LOCAL f2sTmp64:QWORD
LOCAL f2sST0:REAL10, f2sST1:REAL10, f2sST2:REAL10
LOCAL f2sDigits:DWORD
LOCAL f2sExpo:DWORD
LOCAL f2sConWold:WORD, f2sConW:WORD

COMMENT @ ------------------------------------------------------------------------------------------------------
This routine should be called through the float$ macro, so that
the appropriate size can be chosen. The use without this macro
is restricted to REAL8 variables, passed as follows:

	invoke Float2Asc, chr$("\nA test: %f\n\n"), addr MyReal8
	MsgBox 0, eax, "Float test:", MB_OK

	print rv(Float2Asc, chr$("\nA test: %f\n\n"), offset MyReal8)

	print rv(Float2Asc, 0, offset MyReal8)		; prints the plain number

--------	jj2007 September 2008 - use at your own risk --------------------------------------------- @
	push ebx	; save regs
	push edi
	push esi
	mov f2sDigits, f2sPrec			; default
	mov esi, offset f2sBuffer
	mov edi, f2sForm$				; do we have a string  la "The number %f is too small"?
	.if edi
			xor eax, eax
	@@:	mov al, [edi]			; xxx we copy the format string to the output buffer
			test eax, eax
			je @F
			cmp al, "%"
			je @F					; insert number: we are done here

			mov cx, [edi]
			cmp cx, "t\"				; tab?
			jne NoTab
			sub eax, 92-9			; mov al, 9
			inc edi
			jmp NoLf

	NoTab:	cmp cx, "n\"				; newline?
			jne NoLf
			sub eax, 92-13			; mov al, 13
			mov [esi], al
			inc esi
			inc edi
			sub eax, 3				; mov al, 10

	NoLf:	mov [esi], al
			inc edi
			inc esi
			jmp @B

	@@:	mov al, [edi+1]
			.if byte ptr al>"0"
				.if byte ptr al<="9"		; Uppercase F = 15
					and al, 15
					inc edi
					mov f2sDigits, eax	; change precision
				.elseif byte ptr al<="J"	;    1MUppercase F = 15, K=20
					sub al, 55
					inc edi
					mov f2sDigits, eax	; change precision
				.endif
			.endif
			mov f2sForm$, edi	; we'll do the rest after we are finished ...
	.endif						; ... with the number, starting from current esi
	mov edx, offset f2sP10		; v v interleaving saves ca. 5 cycles
	mov ecx, [edx]
	.if ecx==0
		fclex					; clear exceptions; 34 cycles, so we do it only once
	.endif
	fstcw f2sConWold			; status word could be saved as fstsw ax,
	mov ax, f2sConWold		; but no such instruction for Control word
	or ax, 011100000000b		; rounding mode DOWN,
	mov f2sConW, ax			; precision max=64
	fldcw f2sConW				; set new control word
	fstp f2sST0					; save & free 3 registers: 3*(6+6)=36 cycles, in practice 10 per FPU register, 30 cycles
	fstp f2sST1					; No. 2 saved
	mov edi, offset f2sSlots
	fstp f2sST2					; No. 3 saved

	.if ecx==0
		fld f2s0dot1				; ------- create multplier table --------
		fld f2sSeed
		;int 3
		mov ecx, ExRange*2
	@@:
		fmul st, st(1)
		fst REAL8 ptr [edx]		; f2sP10
		add edx, 8
		dec ecx
		jne @B
		fstp st					; pop 2 registers, old
		fstp st					; ST0 will be on top again
	.endif

;    slot 0 taken: it's float$; FF$ or 0, f2sMS, slot 0: arg0, slot 1: arg1 etc
; slots not taken: FF$ or 0, Real8
	mov ebx, f2sMS			; slots taken: AriMode + 8 * Size+ 32 * NegFlag
	mov edx, [edi]				; mov edi moved up for interleaving
	.if edx
		; ************************	  macro mode   *******************************************
NxtSlot:	mov ecx, ebx			; mode & size
		sar ecx, 3
		and ecx, 3				; size only
		.if cl==2
			fld REAL8 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==3
			fld REAL10 ptr [edx]		; load from mem, 6 cycles
		.elseif cl==1
			fld REAL4 ptr [edx]		; load from mem, 3 cycles
		.elseif cl==0
			fild dword ptr [edi]		; push the integer in edx=[edi] (reg or immediate)
		.endif
		mov eax, ebx				; mode
		test eax, 32
		je @F
		fchs					; NegFlag: change sign
@@:		and eax, 7				; mode only
		.if eax
			.if al==1	
				fadd
			.elseif al==2
				fsub
			.elseif al==3
				fmul
			.elseif al==4
				fdiv
			.endif
		.endif
		xor ecx, ecx
		mov [edi], ecx			; flag old slot empty for next invoke
		add edi, 4
		mov edx, [edi]
		sar ebx, 6				; get next 6 bits for size and mode
		test edx, edx
		jne NxtSlot				; slot empty, so outta here
		;    ************************	  end of macro slots  ******************************************
	.else
		fld REAL8 ptr [ebx]		; "normal" invoke instead of macro, load from mem=3 cycles
	.endif
	xor ecx, ecx					; sign flag
	ftst							; test for zero
	mov edi, esi				; we want to insert the number into edi
	fstsw ax
	sahf
	je f2sZero					; 0.0
	jnc f2sPos					; above zero
	mov al, "-"
	fabs						; our number is negative
	mov [edi], al
	inc edi						; edi=start of abs(num)

f2sPos:
	fldlg2						; load constant, 8 cycles
	fld st(1)						; store current number in FPU
;	.if MyInt3
;		int 3
;	.endif
	fyl2x						; log, 196-329 cycles
	fistp f2sExpo				; pop log10(num), i.e. exponent
	mov esi, f2sExpo			; exponent
	mov eax, esi
	sub eax, f2sDigits							; eax is log10, subtract digits to get multiplier
	lea edx, [f2sP10+8*eax+8*(ExRange+6)]	; max precision is 8*2=16	
	fld REAL8 ptr [edx]							; multiply the original number by 1.0 Exx
;	12 digits, expo=9, d=+3: esi=edi+9
;	12 digits, expo=15, d=-3: esi=edi+1, flag sci on
;	12 digits, expo=-1, d=-13: esi=edi+1, flag sci on

	.if signed esi>=0			; esi=f2sExpo
		.if esi>=f2sDigits
			xor esi, esi			; can't fit, so choose SciNot
		.endif
	.elseif signed esi>=SwScNot	; ------------- insert leading zeros ------------- v v
		mov al, "." 
		mov [edi+1], al			; Ascii 46 at pos 1
		add al, 2
		stosb					; mov [edi], al + inc edi: Ascii 48 at pos 0, i.e. leading 0
		mov edx, esi
		.While signed edx<-1	; write some zeros
			inc edi
			inc edx
			mov [edi], al
		.Endw
		or esi, -1				; no other dots please
	.else						; ------------- insert leading zeros ------------- ^ ^
		xor esi, esi				; can't fit, so choose SciNot
	.endif
	; int 3
	fmul						;    normalise to a positive number (16 cycles)
	mov ebx, esi				; flag SciNot
	fld f2sRnd05				; 0.5 - the three instructions cost roughly 3 cycles
	fadd st(1),st					; round the integer upwards by adding 0.5, move result to st(1)
	fstp st						; pop ST

	mov eax, f2sDigits			; ----------- check for rounding 9.99999 problem ----
	neg eax
	lea edx, [f2sP10+8*eax+8*ExRange+8*5]	; get expected value from table
	fld REAL8 ptr [edx]							; load into FPU
	fsubr st, st(1)				; subtract current number
	ftst							; set flags
	fstsw ax					; pop flags
	sahf						; translate
	fstp st
	jb @F						; below: OK
	.if esi
		inc edi					; no SciNo: leave it there but move one dot to the right
	.else
		inc f2sDigits			; SciNo: fake a multiply by ten
		inc f2sExpo
	.endif						; ----------- rounding corrected ---------------------------------

@@:	add esi, edi					; pos to insert the dot, if any
	inc esi
	fistp f2sTmp64				; qword to mem
	lea eax, f2sTmp64			; address to dword to convert
	add edi, f2sDigits			; edi is pointer to end of output buffer
	call qw2Str				; convert to Ascii
	inc edi
	.if ebx==0					; use scientific notation ...
		mov ecx, f2sExpo			 ; ... only if exponent <> 0
		.if ecx
			mov eax, "0+e"				; default
			.if signed ecx<SwScNot		; jge ...
				neg ecx
				add ah, 2				; = mov eax, "0-e"
			.endif
			mov [edi], eax				; +-e0
			mov eax, ecx
			m2m ebx, 10
			xor edx, edx				; for div, edx must be zero
			div ebx						; result in eax, remainder in edx
			add dl, 30h					; last number of exponent
			add edi, 2
			mov [edi+1], dl
			.if signed ecx>=100			; we need less space for the expo
				mov [edi+2], dl			; 96/10=9 in eax, 6 in edx
				xor edx, edx			; for div, edx must be zero
				div ebx					; divide eax by 10 again
				add al, 30h
				stosb					; 1 in eax to left (mov [edi], al+inc edi)
				mov al, dl				; 2 in edx to middle position
			.endif
			add al, 30h
			mov esi, edi
			stosb					;mov [edi], al, inc edi
			inc edi
		.endif
	.endif
	mov byte ptr [edi], 0				; zero delimiter
f2sDone:								; ------------	xxx finish the job  ------------------------
	mov esi, f2sForm$				; did the format string have text after the number?
	.if esi
			inc esi					; get rid of %f
	@@:	inc esi					; v v -------------
			mov al, [esi]
			test al, al
			je @F

			mov cx, [esi]
			cmp cx, "t\"				; tab?
			jne NoT2
			sub eax, 92-9			; mov al, 9
			inc esi
			jmp NoLf2

	NoT2:	cmp cx, "n\"			; newline?
			jne NoLf2
			sub eax, 92-13			; mov al, 13
			stosb
			inc esi
			sub eax, 3				; mov al, 10

	NoLf2:	stosb					;mov [edi], al + inc edi
			jmp @B					; ^ ^ -------------

	@@:	stosb					; mov [edi], al + inc edi
	.endif
	fld f2sST2				; restore 3 registers
	pop esi					; xxx restore regs
	fld f2sST1
	pop edi
	fld f2sST0
	pop ebx
	fldcw f2sConWold		; restore control word
	mov eax, offset f2sBuffer
  ret

f2sZero:
	mov al, "0"
	stosb
	fstp st							; ST0 will be on top again
	jmp f2sDone

Float2Asc endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
qw2Str proc	; qw2Str needs ptr qword in eax, ptr buffer in edx
	push ebp			; credits to  drizz 
	push edi
	push ebx
	push esi
	mov esi, [eax]
	add eax, 4		; 2 bytes longer but 2 cycles faster than mov edi, [eax+4
	mov ebp, edi		; buffer pointer - here passed as edi
	mov edi, [eax]
	test edi, edi		; is there a hi dword? depends on precision...
	jz @F

  @@U64Cvt:	; QWORD conversion loop
	mov eax, 0CCCCCCCDh	; = b0
	mul esi			; get a0*b0 = d1:d0
	mov eax, 0CCCCCCCDh	; = b0 (mov eax up saves 1 cycle)
	mov ecx, edx		; d1
	xor ebx, ebx
	mul edi			; get a1*b0 = e1:e0
	add ecx, eax		; e0
	adc ebx, edx		; e1
	mov eax, 0CCCCCCCCh	; =b1
	mul esi			; get a0*b1 = f1:f0
	add ecx, eax		; f0
	adc ebx, edx		; f1
	push 0			; 5 cycles faster, 3 bytes
	pop ecx			; shorter than mov ecx, 0
	mov eax, 0CCCCCCCCh	; =b1
	adc ecx, ecx
	mul edi			; get a1*b1 = g1:g0
	add eax, ebx		; g0
	adc edx, ecx		; g1
	shrd eax, edx, 3
	shr edx, 3			; ------ quotient in edx::eax

	; upper dwords will be the same after multiplication
	lea ecx, [eax*4+eax]	; ecx=5*eax
	neg ecx			; same speed, 2 bytes shorter
	lea ebx, [esi+2*ecx+"0"]
	mov esi, eax
	cmp ebp, [esp]		; 2 cycles, [esp]=esi
	je InsDot1		; 1 cycle
Dot1Ok:	mov [ebp], bl
	mov edi, edx
	sub ebp, 1		; dec ebp costs 1-2 cycles here
	test edi, edi
	jnz @@U64Cvt

  @@:	; we are here if HI-DWORD is 0
	mov eax, esi
	mov ebx, esi
	mov edi, 0CCCCCCCDh

	; Lower Dword conversion loop
  @@U32Cvt:	mul edi
	shr edx, 3
	lea ecx, [edx*4+edx]	; ecx=edx*5
	neg ecx			; 3 cycles faster
	lea ebx, [ebx+2*ecx+"0"]
	mov eax, edx		; sub ebx, mov eax 2 cycles faster than inverse sequence
	cmp ebp, [esp]		; 2 cycles
	je InsDot2		; 1 cycle
Dot2Ok:	mov [ebp], bl
	mov ebx, edx
	dec ebp			; sub ebp, 1 here a bit slower and 2 bytes more
	test eax, eax
	jnz @@U32Cvt

	pop esi
	pop ebx
	pop edi
	pop ebp
	ret
InsDot1:
	mov cl, "."		; ebx
	mov [ebp], cl
	dec ebp
	jmp Dot1Ok
InsDot2:
	mov cl, "."		; ebx
	mov [ebp], cl
	dec ebp
	jmp Dot2Ok

qw2Str endp
OPTION PROLOGUE:PROLOGUEDEF
OPTION EPILOGUE:EPILOGUEDEF
.const

